; FUNKPLOT berechnen
;--------------------
; von Oliver Saalfeld
; Public Domain (R) 1989 bei ST Vision

ALERT "| FUNKTIONS-PLOTTER |       von|  Oliver Saalfeld|"

;Parameter koennen geaendert werden:
 xachse=10:; Scalierung der X-Achse * 2
 yachse=10:; Scalierung der Y-Achse * 2
 xzoom=20:; Vergroesserung der X-Achse
 yzoom=20:; Vergroesserung der Y-Achse
 funkzoom=500:; Vergroesserung der Funktionshoehe
 special=10:; Einteilen der Funktionshoehe in X Einheiten
 loop=special:; Berechnen der X-ten Einheit
;Parameterende

; Grundparameter von CAD-3D einstellen
ZOOM 450:PERSPEC 999
DRAFT:VIEW HIDDEN
CAM1 30,30,0

; Funktion berechnen
GOSUB FUNKTION
END

; FUNKTION
;----------
; Unterprogramm zum Berechnen
; von 3d-Funktionen.
; 
; von Oliver Saalfeld 
; 
; Public Domain (R) 1989 bei ST Vision

; Parameter:
; xachse,yachse,xzoom,yzoom,funkzoom,special,loop
 
@FUNKTION
if xachse*yachse*4>1400 then goto error2
x2=(xachse*2)+1
m=0
FOR y = -yachse TO yachse
  FOR x = -xachse TO xachse
    ;Funktion:
    f=(COS(x*xzoom)*COS(y*yzoom))*funkzoom
    ; Funktion steigen und sinken lassen
    g=(f/special)
    f=g*loop
    ; Funktion nicht zu hoch 
    IF f>3500 THEN f=3500
    IF f<-3500 THEN f=-3500
    ; Bestimmung des Punktes
    ADDVERTEX m,x*100,y*100,f
    m=m+1
  NEXT x
NEXT y
; Berechnung der Funktionsflaechen
n=0
FOR y = 0 TO (yachse*2)-1
  FOR x = 0 TO (xachse*2)-1
    ; Bestimmung der Flaechen
    ADDFACE n,x+(y*x2),x+1+(y*x2),x+x2+(y*x2),1,0,1,14
    n=n+1
    ADDFACE n,x+1+(y*x2),x+x2+1+(y*x2),x+x2+(y*x2),1,1,0,14
    n=n+1
  NEXT x
NEXT y
; Funktion in CAD-3D einlesen
if m>1400 then goto error4
if n>2800 then goto error5
UPLOAD Funktion,m,n
SELECT Funktion
RETURN
@error2
alert " | FUNKTION: Fehler 2 | | Parameter falsch! "
end
@error4
alert " | FUNKTION: Fehler 4 | | Zu viele Punkte! "
end
@error5
alert " | FUNKTION: Fehler 5 | | Zu viele Flaechen! "
end
; (FUNKTION-Ende)